package xtremelyvirtualstudios.xvs.Streamer;



import android.media.AudioManager;
import android.media.MediaPlayer;
import android.media.MediaRecorder;
import android.util.Log;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Permissions;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;

@ShortName("Streamer")
@Permissions(values = {"android.permission.WRITE_EXTERNAL_STORAGE", "android.permission.RECORD_AUDIO"})
@Author("XverhelstX")
@Version(1.2f)

public class Streamer {
	
    MediaRecorder mRecorder = null;
    MediaPlayer mPlayer = new MediaPlayer();
    private boolean mIsPrepared;
    

       
    /**
     * Starts the audio stream. Can take a while to load and can lagg.
     * for links:  please make sure it ends with audiotypes: 
     * e.g: http://www.freewebs.com/thebirdsmedia/faint.mp3
     */
	
	public void StartAudioStream(String URL) {
		 
		
		  try {
	       mIsPrepared = false;
		   mPlayer.setDataSource(URL);
		   mPlayer.setAudioStreamType(AudioManager.STREAM_MUSIC);
		   mPlayer.prepare();
		   mIsPrepared = true;
		   mPlayer.start();

		  } catch (Exception e) {
		   Log.i("Exception", "Exception in streaming mediaplayer e = " + e);
		  }
		 }

    /**
     * Stops the current stream.
     * 
     */
	public void StopAudioStream() {
		
        mPlayer.stop();
		}
	
	
	public boolean IsStreaming(){
	
		if (mPlayer != null && mIsPrepared == true) {
            return mPlayer.isPlaying();
        }
		return false;
        
    }
	
    public void PauseStream() {
        if (mPlayer != null && mIsPrepared == true) {
            if (mPlayer.isPlaying()) {
            	mPlayer.pause();
            }
        }
        
    }
    
    public int getAudioDuration() {
        if (mPlayer != null && mIsPrepared == true) {
            return mPlayer.getDuration();
        }
        return -1;
    }
    
    public boolean canSeekForward() {
        return true;
      }

      public boolean canSeekBackward() {
        return true;
      }

      public boolean canPause() {
        return true;
      }
				
}
		
	
	